UbixOS V2 2.0

Typedefs | Functions
sio.h File Reference
`#include "net/arch.h"`
`#include "net/opt.h"`
Include dependency graph for sio.h:

Go to the source code of this file.

## Typedefs
typedef void * | sio_fd_t

## Functions
sio_fd_t | sio_open (u8_t devnum)
u32_t | sio_read (sio_fd_t fd, u8_t *data, u32_t len)
void | sio_read_abort (sio_fd_t fd)
u8_t | sio_recv (sio_fd_t fd)
void | sio_send (u8_t c, sio_fd_t fd)
u32_t | sio_tryread (sio_fd_t fd, u8_t *data, u32_t len)
u32_t | sio_write (sio_fd_t fd, u8_t *data, u32_t len)

## Typedef Documentation

## ◆ sio_fd_t

typedef void* sio_fd_t

Definition at line 48 of file sio.h.

## Function Documentation

## ◆ sio_open()

sio_fd_t sio_open | ( | u8_t | devnum | ) |

Opens a serial device for communication.

Parameters

  devnum | device number

Returns
  handle to serial device if successful, NULL otherwise

## ◆ sio_read()

u32_t sio_read | ( | sio_fd_t | fd,
|  | u8_t * | data,
|  | u32_t | len
| ) |  |

Reads from the serial device.

Parameters

  fd | serial device handle
  data | pointer to data buffer for receiving
  len | maximum length (in bytes) of data to receive

Returns
  number of bytes actually received - may be 0 if aborted by sio_read_abort

Note
  This function will block until data can be received. The blocking can be cancelled by calling sio_read_abort().

## ◆ sio_read_abort()

void sio_read_abort | ( | sio_fd_t | fd | ) |

Aborts a blocking sio_read() call.

Parameters

  fd | serial device handle

## ◆ sio_recv()

u8_t sio_recv | ( | sio_fd_t | fd | ) |

Receives a single character from the serial device.

Parameters

  fd | serial device handle

Note
  This function will block until a character is received.

## ◆ sio_send()

void sio_send | ( | u8_t | c,
|  | sio_fd_t | fd
| ) |  |

Sends a single character to the serial device.

Parameters

  c | character to send
  fd | serial device handle

Note
  This function will block until the character can be sent.

## ◆ sio_tryread()

u32_t sio_tryread | ( | sio_fd_t | fd,
|  | u8_t * | data,
|  | u32_t | len
| ) |  |

Tries to read from the serial device. Same as sio_read but returns immediately if no data is available and never blocks.

Parameters

  fd | serial device handle
  data | pointer to data buffer for receiving
  len | maximum length (in bytes) of data to receive

Returns
  number of bytes actually received

## ◆ sio_write()

u32_t sio_write | ( | sio_fd_t | fd,
|  | u8_t * | data,
|  | u32_t | len
| ) |  |

Writes to the serial device.

Parameters

  fd | serial device handle
  data | pointer to data to send
  len | length (in bytes) of data to send

Returns
  number of bytes actually sent

Note
  This function will block until all data can be sent.